Loading...
Searching...
No Matches
AwsRestClient::AwsRestConnection Class Reference

class for AWS REST connections; returns AwsRestClient::AwsRestClient objects More...

Inheritance diagram for AwsRestClient::AwsRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the AwsRestConnection object
DataProvider::AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection
string | getType ()
| returns `"awsrest"`
bool | hasDataProvider ()
| returns True, as this connection always returns a data provider with the getDataProvider() method

## Public Attributes

const | ConnectionScheme
| Connection entry info.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
AwsRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a AwsRestClient::AwsRestClient object

## Detailed Description

class for AWS REST connections; returns AwsRestClient::AwsRestClient objects

supports the following options:

- `"aws_keyid"`: (required) AWS key ID
- `"aws_region"`: (required) the AWS region to use (ex: `"us-east-1"`)
- `"aws_s3"`: (optional) set to True to flag this object for use with AWS S3, which requires special message encoding
- `"aws_secret"`: (required) the AWS secret access key value
- `"aws_service"`: (required) the AWS service to use (ex: `"iam"`)
- `"aws_token"`: (optional) a temporary session token from AWS Security Token Service for this HTTP session
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"error_passthru"`: if True then HTTP status codes indicating errors will not cause a `REST-RESPONSE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"redirect_passthru"`: if True then redirect responses will be passed to the caller instead of processed
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"timeout"`: transfer timeout to use in milliseconds

Note
  the `data` option is always set to `"json"`

See also
  AwsRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor()

AwsRestClient::AwsRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the AwsRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getDataProvider()

DataProvider::AbstractDataProvider AwsRestClient::AwsRestConnection::getDataProvider | ( |  | ) |

returns a data provider object for this connection

Returns
  a data provider object for this connection; the data provider is:
  - `SwaggerDataProvider:` if an appropriate schema is configured
  - `RestClientDataProvider:` if there is no schema configured

Exceptions

  DATA-PROVIDER-ERROR | this object does not support the data provider API

## getImpl()

AwsRestClient AwsRestClient::AwsRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a AwsRestClient::AwsRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a AwsRestClient object

## hasDataProvider()

bool AwsRestClient::AwsRestConnection::hasDataProvider | ( |  | ) |

returns True, as this connection always returns a data provider with the getDataProvider() method

Returns
  True, as this connection always returns a data provider with the getDataProvider() method

See also
  getDataProvider()